dat = read.table("D:/FIN_PORTAL/MISC/IREX_wikifolio_analysis/OnlySellTrades.txt", header=TRUE, sep=";")
weightedRets = (dat$Profit * dat$Weight)
smallRets = weightedRets[which(abs(weightedRets)<=0.01)]
ts.plot(weightedRets)
bigRets = weightedRets[which(abs(weightedRets)>0.01)]
ts.plot(smallRets)
ts.plot(bigRets)

allDat = read.table("D:/FIN_PORTAL/MISC/IREX_wikifolio_analysis/AllTrades.txt", header=TRUE, sep=";")
portfolio = list()
cashMovePerISIN = list() #we consider buys
n_transactions = list()
n_sell_transactions = list()
N = dim(allDat)[1] #35095
cash = array(100000, dim=(N+1)) #cash dynamics 
wealth = array(0, dim=N) #total wealth dynamics 
for(k in 1:N)
{
  idx = as.character(allDat$ISIN[k])
  if(is.null(portfolio[[idx]])) #no such isin in portfolio, we buy it first time
  {
     portfolio[[idx]] = allDat$Volume[k] * allDat$Price[k]
     cash[k+1] = cash[k] - allDat$Volume[k] * allDat$Price[k] 
     n_transactions[[idx]] = 1
     n_sell_transactions[[idx]] = 1 #fiktive initialization, will correct below by subtracting -1
     cashMovePerISIN[[idx]] = allDat$Volume[k] * allDat$Price[k] 
  }
  else
  {
      if(as.character(allDat$TransactionType[k]) == "Quote Verkauf") #sell
      {
        portfolio[[idx]] = portfolio[[idx]] - allDat$Volume[k] * allDat$Price[k]
        cash[k+1] = cash[k] + allDat$Volume[k] * allDat$Price[k]
        n_transactions[[idx]] = n_transactions[[idx]]+1
        n_sell_transactions[[idx]] = n_sell_transactions[[idx]] + 1
      }
      else #buy (add)
      {
        portfolio[[idx]] = portfolio[[idx]] + allDat$Volume[k] * allDat$Price[k]
        cash[k+1] = cash[k] - allDat$Volume[k] * allDat$Price[k]
        n_transactions[[idx]] = n_transactions[[idx]]+1 
        cashMovePerISIN[[idx]] = c(cashMovePerISIN[[idx]], allDat$Volume[k] * allDat$Price[k])
      }   
  }
  wealth[k] = cash[k+1] + sum(unlist(portfolio)) 
}
par(mar=c(12,4,2,1)) 
titel ="Wikifolio IREX (DE000LS9JBB2) - Absolute PnL per ISIN - from 25.02.2016 to 11.06.2017"
plot(-unlist(portfolio),  xaxt="n", xlab="", ylab="", main=titel) #NB "-"unlist() 
labelz = paste0(names(portfolio)," [",n_transactions, "]")
axis(side=1, at=seq(1:(length(labelz))), labels=labelz , las=2)
abline(v=seq(1:length(labelz)), lty=3)
abline(h=0, lty=3, col="red") 

###############################################################################
tail(cash,1)-sum(unlist(portfolio))
n_sell_transactions = unlist(n_sell_transactions) - 1 #"-1" is correction, s.above
n_transactions = unlist(n_transactions)
par(mfrow=c(2,1))
plot(n_sell_transactions/n_transactions, , xlab="", ylab="", main="N of SELL transaction / N of TOTAL trans")
axis(side=1, at=seq(1:(length(labelz))), labels=names(portfolio) , las=2)
plot(n_transactions, n_sell_transactions/n_transactions, main="\r\nRATIO N of SELL / N of TOTAL vs N of TOTAL")

###############################################################################
par(mar=c(10,4,2,1))
boxplot(cashMovePerISIN, las=2, main="Wikifolio IREX - boxplot of cash amount by BUYs")